import java.util.Iterator;
import java.util.List;
import java.util.Properties;


import aima.search.framework.Problem;
import aima.search.framework.Search;
import aima.search.framework.SearchAgent;
import aima.search.framework.TreeSearch;
import aima.search.uninformed.BreadthFirstSearch;
import aima.search.uninformed.DepthFirstSearch;
import aima.search.uninformed.DepthLimitedSearch;

public class Demo {

	public static void main(String[] args) {
		
		MCStato statoIniziale = new MCStato();
		
		Problem problema = new Problem(statoIniziale, new MCFunzioneSuccessore(), new MCStato());
		
		//ricerca in ampiezza su albero
		Search strategia = new BreadthFirstSearch(new TreeSearch());

		/* ricerca in profondit su albero 
		 * Loop infinito genera errore di memoria. */
	    //Search strategia = new DepthFirstSearch(new TreeSearch());
		/* Si pu evitare imponendo un limite sulla profondit > della profondit del goal 
		   Search strategia = new DepthLimitedSearch(20); 
		 * */
		
		SearchAgent agente;
		try {
			agente = new SearchAgent(problema, strategia);
			
			printActions(agente.getActions());
			printInstrumentation(agente.getInstrumentation());
		
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private static void printInstrumentation(Properties properties) {
		Iterator keys = properties.keySet().iterator();
		while (keys.hasNext()) {
			String key = (String) keys.next();
			String property = properties.getProperty(key);
			System.out.println(key + " : " + property.toString());
		}

	}

	private static void printActions(List actions) {
		for (int i = 0; i < actions.size(); i++) {
			String action = (String) actions.get(i);
			System.out.println(action);
		}
	}
}
