import aima.search.framework.GoalTest;
import aima.search.framework.StepCostFunction;


public class MCStato implements GoalTest, StepCostFunction{

	private int cannibali;
	private int missionari;
	private boolean barca;
	
	//metodi getter che restituiscono il numero di M/C e la presenza della barca sulla *sponda iniziale* (riferimento)
	public int getCannibali() {
		return cannibali;
	}
	
	public int getMissionari() {
		return missionari;
	}
	
	//true se la barca  sulla sponda di partenza, false se sulla sponda opposta
	public boolean isBarca() {
		return barca;
	}
	
	//costruttori
	//stato generico
	public MCStato(int m, int c, boolean b) {
		this.missionari = m;
		this.cannibali = c;
		this.barca = b;
	}
	
	//stato iniziale
	public MCStato() {
		this(3, 3, true);
	}

	@Override
	//restituisce true (stato obiettivo) se sulla sponda di partenza non ci sono pi persone n la barca
	public boolean isGoalState(Object stato) {
		if (stato instanceof MCStato) {
			MCStato temp = (MCStato)stato;
			return ((temp.barca == false) && (temp.cannibali==0) && (temp.missionari==0));
		} else 
			return false;
	}

	@Override
	//costo di uno step (traversata)
	public Double calculateStepCost(Object arg0, Object arg1, String arg2) {
		return 1.0;
	}
}
